(*  Title:      ISM/dAmbISM.thy
    Id:         $Id: dAmbISM.thy,v 1.14 2003/03/04 17:28:19 dvo Exp $
    Author:     David von Oheimb
    License:    (C) 2002 Siemens AG; any non-commercial use is granted

*)

header {* dynamic Ambient ISMs *}

theory dAmbISM
imports dISM AmbISM
begin
types ('i, 'p, 'a) dastate = "('i, 'p) dstate    \<times> ('i, 'a) astate"
types ('i, 'p, 'a) dacmds  = "('i, 'p) dcmd list \<times> ('i, 'a) acmd list"

constdefs
  dAmb_trans :: "('i, ('i, 'p, 'a) dacmds, ('i, 'p, 'a) dastate) g_trans"
 "dAmb_trans \<equiv> \<lambda>i. {((di, ai),(dcmds, acmds),(di', ai')).
      (di,dcmds,di') \<in> d_trans {j. home ai i \<in> Some`vicinity ai j} i \<and> 
      (ai,acmds,ai') \<in> Amb_trans i}"

  dAmb_comp_runs :: 
 "('i, (('i, 'p, 'a) dacmds, 'p, 'm, 's) ism) family \<Rightarrow> 'i set \<Rightarrow> ('i, 'a) astate \<Rightarrow> 
  ((('p, 'm, (('i, 'p, 'a) dastate) \<times> ('i \<Rightarrow> 's)) conf) list) set"
 "dAmb_comp_runs AI run ai0 \<equiv> 
    comp_runs (\<lambda>(di,ai). local_output (set_in_out AI di) ai) 
              (init_dstate AI run, ai0) dAmb_trans"
--{* inherits port handling and dAmbISM creation/deletion from dynamic ISMs *}
--{* inherits ambients from Ambient ISMs *}
--{* effects of @{term Run}, @{term Stop}, and @{term Convey} are restricted to dAmbISMs in the same ambient *}

(*<*)
lemma snd_local_output_eq [simp]: "\<And>AI. snd (local_output AI ai) = snd AI"
by (auto simp add: local_output_def)

(*>*)
lemma dAmb_comp_runs_preserves_wf_comp: 
 "wf_comp AI \<Longrightarrow> cs \<in> dAmb_comp_runs AI run ai0 \<Longrightarrow> 
  \<forall>(b,di_ai,s) \<in> set cs. wf_comp (local_output (set_in_out AI (fst di_ai)) (snd di_ai))"
(*<*)
apply (unfold dAmb_comp_runs_def)
apply (rule_tac ginit = "(init_dstate AI run, ai0)" in 
       comp_runs_global_induct, simp_all add: split_paired_all)
apply   (simp add: split_def)
apply  (erule wf_comp_set_in_out_init_dstateI)
apply (clarsimp simp add: dAmb_trans_def)
apply (erule (2) d_trans_preserves_wf_comp_set_in_out)
done
(*>*)

end

